#!/bin/bash
#DISPLAY=:99.0 LANG=ru_RU.UTF-8 XAUTHORITY=/home/ceasar/.Xauthority /home/ceasar/ARC1C.sh
#DISPLAY=:99.0 LANG=ru_RU.UTF-8 /home/ceasar/ARC1C.sh
#Автономный сервер для выгрузки баз 1с
#ibcmd infobase dump --db-server=localhost --dbms=MSSQLServer --db-name=sb_demo --db-user=test_db_user --db-pwd=test_pwd_123 --user=user1c --password=pass_1c "%tmp%\sb_demo.dt"
#*******************************************************************************************
#********************** Ввод первоначальных данных *****************************************
#*******************************************************************************************

# Переменная пути, где будут сохраняться выгрузки из баз
# Можно указать через ; несколько путей, в конце обязательно\
patharcall="/media/ARC/ARC/;/media/sf_ARC/"

# Путь до файла со списком баз 1С
file1c=~/.1C/1cestart/ibases.v8i

#Имя пользователя к базам 1С для выгрузок
username="User1C"
#Пароль к пользователю баз 1С
userpw="passwordUser1C"
#Пароль sudo
sudopw="passwordsudo"

# Здесь переменные для подключения к серверу баз данных
# имя пользователя сервера баз данных
userpg=postgres
# пароль пользователя сервера баз данных
passpg=passwordpostgres

# Переменная отвечает за день недели в который будет происходить создание недельной копии
# Понедельник - 1 ..... Воскресенье - 7
weekday="5"
# Переменная отвечает за день месяца в который будет происходить создание месячной копии
monthday="01"
# Переменная отвечает за то, сколько резервных копий оставлять
copysave=4
# Переменная задает тип сохранения для файловой базы
# 0 - архив папки, 1 - выгрузка 1С
fbasetype="1"
# Переменная задает тип сохранения для серверной базы
# 0 - дамп базы из сервера, 1 - выгрузка 1С
sbasetype="1"
# Переменная задает тип сервера базы данных
# 0 - MsSQL, 1 - posgresql
sqltype="1"
# Переменная задает имя сервера баз, если она здесь не задана, то считается, что
# сервер баз данных и сервер 1с это одно и тоже, задается без кавычек, просто имя
servbd=""
# Переменная указывает на использование конкретной версии 1с, задается в кавычках
# например "8.3.15.1830", если же версия не задана, то должны стоять кавычки ""
ispolzovatvers=""
# Переменная задает будет ли проводиться очистка базы данных от логов
# 0 - очистка не проводится, 1 - очистка проводится
clearbd="0"
# Переменная задает будет ли проводиться реиндексация базы
# 0 - реиндексация не проводится, 1 - реиндексация проводится
reindex="0"
#Переменная задает возможность полного доступа к созданным файлам для других пользователей
#  0 - не полный доступ, 1 - полный доступ
fullaccess="1"
#Сколько сделать попыток выгрузки из базы при создании выгрузки
popytki=5


#*******************************************************************************************
#********************* Ввод первоначальных данных завершен *********************************
#*******************************************************************************************

# Проверим задана ли конкретная версия 1С и существует ли она, если нет то будем искать существующую
vers=""
if [ "$ispolzovatvers" != '' ];
then
              # Проверим наличие 1с такой версии
              if [ $(du -k "/opt/1cv8/x86_64/$ispolzovatvers/1cv8" | cut -f 1) -ge 0 ];
                              then
                              vers=$ispolzovatvers
              fi
fi

#Определяем максимально установленную версию 1С
if [ "$vers" = '' ];
then
for name in $(find /opt/1cv8/x86_64 -maxdepth 1 | sort );
do
vers="1"
vers=${name:17}
done
fi

if [ "$vers" != '' ];
then
versrel=${vers:4}
versrel=${versrel::-5}
else
versrel="15"
fi

#Определяем путь до 1С
if [ "$vers" = '' ];
then
path1c="/opt/1C/v8.3/x86_64"
else
path1c="/opt/1cv8/x86_64/$vers"
fi

#Определим параметры для автосервера 1С
if [[ $sqltype == "1" ]]
    then
        sqltypestr="PostgreSQL"
    else
        sqltypestr="MSSQLServer"
    fi

# Проверим можно ли использовать автономный сервер
if [ $(du -k "$path1c/ibcmd" | cut -f 1) -ge 0 ];
                              then
                              avtserver1c="1"
                              else
                              avtserver1c="0"
                              fi
# Переменная avtserver1c задает режим использования автономного сервера 1С
# 0 - не использовать, 1 - использовать


copysave=$((copysave+1))

label1(){
#Завершаем работу всех сессий на сервере 1C
sudo $path1c/ras --daemon cluster
for cluster in $(sudo $path1c/rac cluster list | grep 'cluster'); do
if [ "$cluster" != 'cluster' ] &&  [ "$cluster" != ':' ];
then
echo $cluster
fi
done
#Теперь непосредственно завершаем рабочие сессии на сервере 1С
echo 'Вот список сессий на сервер:'
i="0"
for sessionserver in $(sudo $path1c/rac session --cluster=$cluster  list); do
if [ "$sessionserver" == 'session' ];
then
i="0"
else
let "i += 1"
if [ "$i" == "2" ];
         then
         sudo $path1c/rac session --cluster=$cluster terminate --session=$sessionserver
         echo $sessionserver
         fi
fi
done
}

apachestop="0"

label2(){
#Отключаем apache, что бы выкинуть пользователей 1С
if [[ $apachestop == "0" ]]
    then
        echo $sudopw | sudo -S service apache2 stop
        sudo systemctl stop apache2
        apachestop="1"
    fi
}

label3(){
#Убиваем все 1С, запущенные на сервере
echo $sudopw | sudo -S killall -SIGKILL 1cv8
echo $sudopw | sudo -S killall -SIGKILL 1cv8c
echo $sudopw | sudo -S killall -SIGKILL 1cv8s
echo $sudopw | sudo -S service srv1cv83 restart
}

# Устанавливаем дату
DATA=`date +"%Y-%m-%d_%H-%M-%S"`
DAY=$(date +"%d")
DOW=$(date +%u)


namestart="0"
basenamex=""
basename=""
typebase=""
pahtbase=""
serverbase=""
postgresbase=""
pathtrue="0"
#Читаем файл записей баз 1С
while read LINE
 do

    if [[ $LINE =~ "[" ]]
    then
        namestart="1"
        basename=""
        typebase=""
        pahtbase=""
        serverbase=""
        postgresbase=""
        pathtrue="0"
    fi

#Начинаем сборку имени базы   
if [[ $basename == "" ]]
then

  if [[ $namestart == "0" ]]
    then
        echo $LINE
    else
        basenamex="$basenamex $LINE"
    fi
    
  if [[ $LINE =~ "]" ]]
    then
        namestart="0"
        basename=${basenamex:2}
        basename=${basename::-2}
        if [[ $basename =~ "[" ]]
           then
               basename=${basename:1}
           fi
        echo $basename
	basenamex=""
    fi
fi 
#Закончилась сборка имени базы

    if [[ $LINE =~ "Connect=ws=" ]]
    then
        typebase="3"
        pahtbase=${LINE:12}
        pahtbase=${pahtbase::-3}
        pathtrue="0"
    fi

    if [[ $LINE =~ "Connect=Srvr=" ]]
    then
        typebase="2"
        pahtbase=${LINE:14}
        pahtbase=${pahtbase::-3}
        serverbase=${pahtbase%'"'*}
        serverbase=${serverbase::-6}
        serverbase=$serverbase'\'
        postgresbase=${pahtbase#*'"'}
        postgresbase=${postgresbase:6}
        pathtrue="1"
    fi
    
    if [[ $LINE =~ "Connect=File=" ]]
    then
        typebase="1"
        pahtbase=${LINE:14}
        pahtbase=${pahtbase::-3}
        pathtrue="1"
    fi
# Мы определили и имя базы и путь до базы при этом namestart="0" pathtrue="1"
#Можно создавать архивы

if [ "$namestart" = '0' ] && [ "$pathtrue" = '1' ];
then
       case $typebase in
                       1)
                          # Устанавливаем дату
			  DATA=`date +"%Y-%m-%d_%H-%M-%S"`
                          IFS=';' read -ra my_array <<< "$patharcall"
                          # Печать разделенной строки
                          for i in "${my_array[@]}"
                          do
                              mkdir -p "$i$basename/День" "$i$basename/Неделя" "$i$basename/Месяц"
			      chmod -R 777 "$i$basename/День"
			      chmod -R 777 "$i$basename/Неделя"
			      chmod -R 777 "$i$basename/Месяц"
                          done
                          patharc=${my_array[0]}
                          if [ "$fbasetype" = '0' ];
                          then
                              label2;
                              label3;
                              echo "создаем архивную копию папки с базой"
                              rashirenie=.tar.gz
                              filemane=$patharc$basename/День/$DATA-День-$basename$rashirenie
                              pathfilename=$patharc$basename/День
                              find "$pahtbase/" -printf "%P\n" -type f -o -type l -o -type d | tar -cvzf "$filemane" --no-recursion -C "$pahtbase/" -T -
                          else
                              label2;
                              label3;
                              echo "создаем выгрузку файловой базы"
                              rashirenie=.dt
                              filemane=$patharc$basename/День/$DATA-День-$basename$rashirenie
                              pathfilename=$patharc$basename/День
                              $path1c/1cv8 CONFIG /F"$pahtbase" /N"$username" /P"$userpw" /DumpIB"$filemane"
                          fi
                          # теперь копируем созданную выгрузку во все папки с архивами
                          if  [ "$fullaccess" = '1' ];
                                  then
                                      #Если выбран полный доступ для всех
				      chmod 777 "$filemane"
                          fi
                          for i in "${my_array[@]}"
                          do
                              # Разбираемся с дневными копиями
                              pathfilename=$i$basename/День
                              filemanen=$i$basename/День/$DATA-День-$basename$rashirenie
                              if [ "$patharc" != "$i" ];
                              then
                                  cp "$filemane" "$filemanen"
                                  if  [ "$fullaccess" = '1' ];
                                  then
                                      #Если выбран полный доступ для всех
				      chmod 777 "$filemane"
                                  fi
                              fi
                              #Оставляем в папке с бэкапами день только copysave резервных копий
                              #find "$pathfilename" -type f -mtime +4 -exec rm -rf {} \;
                              find "$pathfilename" -type f | sort -sr -k1 | tail -n +$copysave | sed 's/^/"/'| sed 's/$/"/' | xargs rm -rf
                              # Разбираемся с недельными копиями
                              pathfilename=$i$basename/Неделя
                              filemanen=$i$basename/Неделя/$DATA-Неделя-$basename$rashirenie
                              if [ "$DOW" = "$weekday" ];
                              then
                                  cp "$filemane" "$filemanen"
                                  chmod 777 "$filemanen"
                              fi
                              #Оставляем в папке с бэкапами неделя только copysave резервных копий
                              #find "$pathfilename" -type f -mtime +28 -exec rm -rf {} \;
                              find "$pathfilename" -type f | sort -sr -k1 | tail -n +$copysave | sed 's/^/"/'| sed 's/$/"/' | xargs rm -rf
                              # Разбираемся с месячными копиями
                              pathfilename=$i$basename/Месяц
                              filemanen=$i$basename/Месяц/$DATA-Месяц-$basename$rashirenie
                              if [ "$DAY" = "$monthday" ];
                              then
                                  cp "$filemane" "$filemanen"
                                  chmod 777 "$filemanen"
                              fi
                              #Оставляем в папке с бэкапами месяц только copysave резервных копий
                              #find "$pathfilename" -type f -mtime +112 -exec rm -rf {} \;
                              find "$pathfilename" -type f | sort -sr -k1 | tail -n +$copysave | sed 's/^/"/'| sed 's/$/"/' | xargs rm -rf
                          done
                        ;;





                       2)
                          # Устанавливаем дату
			  DATA=`date +"%Y-%m-%d_%H-%M-%S"`
                          IFS=';' read -ra my_array <<< "$patharcall"
                          # Печать разделенной строки
                          for i in "${my_array[@]}"
                          do
                              mkdir -p "$i$basename/День" "$i$basename/Неделя" "$i$basename/Месяц"
			      chmod -R 777 "$i$basename/День"
			      chmod -R 777 "$i$basename/Неделя"
			      chmod -R 777 "$i$basename/Месяц"
                          done
                          patharc=${my_array[0]}
                          if [ "$sbasetype" = '0' ];
                          then
                              echo "создаем выгрузку базы из postgressql"
                              rashirenie=.dump
                              filemane=$patharc$basename/День/$DATA-День-$basename$rashirenie
                              pathfilename=$patharc$basename/День
                              var1=$popytki
                              while [ $var1 -gt 0 ]
                              do
                              var1=$[ $var1 - 1 ]
                              if [ "$sqltype" = '1' ];
                              then
				  sudo -H -u $userpg pg_dump -F c -Z 9 -U $userpg --file="$filemane" $postgresbase
                                  #PGPASSWORD=$sudopw pg_dump -F c -Z 9 -U $userpg --file="$filemane" $postgresbase
                              else
                                  sqlcmd -S localhost -U $userpg -P $passpg -Q "BACKUP DATABASE [$postgresbase] TO DISK = N'$filemane' WITH NOFORMAT, NOINIT,  NAME = N'$postgresbase-full', SKIP, NOREWIND, NOUNLOAD, COMPRESSION,  STATS = 10"
                              fi
                              if [ $(du -k "$filemane" | cut -f 1) -ge 0 ]; then
                              var1=0
                              fi
                              done
                              #Проводим очистку и реиндексацию базы для PostgreSQL
                              if [ "$DOW" = "$weekday" ];
                              then
			         #Проводим очистку и реиндексацию базы для PostgreSQL
                                  if  [ "$clearbd" = '1' ] && [ "$sqltype" = '1' ];
                                  then
                                      #Проводим очистку базы
				      echo "Проводим очистку базы: "$postgresbase
				      sudo -H -u $userpg vacuumdb --full --analyze --username $userpg --dbname $postgresbase
                                  fi

			          if  [ "$reindex" = '1' ] && [ "$sqltype" = '1' ];
                                  then
				      #Проводим реиндексацию
				      echo "Проводим реиндексацию базы: "$postgresbase
				      sudo -H -u $userpg reindexdb --username $userpg --dbname $postgresbase
                                  fi
                               fi
                              
                          else
                              echo "создаем выгрузку базы с сервера 1С"
                              rashirenie=.dt
                              filemane=$patharc$basename/День/$DATA-День-$basename$rashirenie
                              pathfilename=$patharc$basename/День
                              var1=$popytki

                              # Разберемся с сервером баз данных, если он задан то он такой, если нет, то он как сервер 1с
                              if [[ $servbd == "" ]];
                              then
                              srvbd=${serverbase%':'*}
                              srvbd=${srvbd%'\'*}
                              else
                              srvbd=$servbd
                              fi
                              # Пробуем выгрузить через авто сервер
                              while [ $var1 -gt 0 ]
                              do
                              var1=$[ $var1 - 1 ]
                              if [ $avtserver1c = "1" ];
                                 then
                                     if (($versrel > 17)) ; then $path1c/ibcmd infobase dump --db-server=$srvbd --dbms=$sqltypestr --db-name=$postgresbase --db-user=$userpg --db-pwd=$passpg --user=$username --password=$userpw "$filemane";
                                                            else $path1c/ibcmd infobase dump --db-server=$srvbd --dbms=$sqltypestr --db-name=$postgresbase --db-user=$userpg --db-pwd=$passpg "$filemane";
                                     fi
                              fi

                              if [ $(du -k "$filemane" | cut -f 1) -ge 0 ];
                              then
                              var1=0
                              fi
                              done
   
                              # Если выгрузка через автономны сервер не удалась, то нужно попробовать выгрузить через конфигуратор
                              if [ $(du -k "$filemane" | cut -f 1) -ge 0 ];
                              then
                              var1=0
                              else
                              var1=$popytki
                              label2;
                              label3;
                              label1;
                              label1;
                              label1;
                              fi

                              while [ $var1 -gt 0 ]
                              do
                              var1=$[ $var1 - 1 ]
                              label1;
                              label1;
                              $path1c/1cv8 CONFIG /S"$serverbase$postgresbase" /N"$username" /P"$userpw" /DumpIB"$filemane"
                              if [ $(du -k "$filemane" | cut -f 1) -ge 0 ];
                              then
                              var1=0
                              fi
                              done

                              #Проводим очистку и реиндексацию базы для PostgreSQL
                              if [ "$DOW" = "$weekday" ];
                              then
			         #Проводим очистку и реиндексацию базы для PostgreSQL
                                  if  [ "$clearbd" = '1' ] && [ "$sqltype" = '1' ];
                                  then
                                      #Проводим очистку базы
				      echo "Проводим очистку базы: "$postgresbase
				      sudo -H -u $userpg vacuumdb --full --analyze --username $userpg --dbname $postgresbase
                                  fi

			          if  [ "$reindex" = '1' ] && [ "$sqltype" = '1' ];
                                  then
				      #Проводим реиндексацию
				      echo "Проводим реиндексацию базы: "$postgresbase
				      sudo -H -u $userpg reindexdb --username $userpg --dbname $postgresbase
                                  fi
                               fi
                          fi
                          # теперь копируем созданную выгрузку во все папки с архивами
                          if  [ "$fullaccess" = '1' ];
                                  then
                                      #Если выбран полный доступ для всех
				      chmod 777 "$filemane"
                          fi
                          for i in "${my_array[@]}"
                          do
                              # Разбираемся с дневными копиями
                              pathfilename=$i$basename/День
                              filemanen=$i$basename/День/$DATA-День-$basename$rashirenie
                              if [ "$patharc" != "$i" ];
                              then
                                  cp "$filemane" "$filemanen"
                                  if  [ "$fullaccess" = '1' ];
                                  then
                                      #Если выбран полный доступ для всех
				      chmod 777 "$filemane"
                                  fi
                              fi
                              #Оставляем в папке с бэкапами день только copysave резервных копий
                              #find "$pathfilename" -type f -mtime +4 -exec rm -rf {} \;
                              find "$pathfilename" -type f | sort -sr -k1 | tail -n +$copysave | sed 's/^/"/'| sed 's/$/"/' | xargs rm -rf
                              # Разбираемся с недельными копиями
                              pathfilename=$i$basename/Неделя
                              filemanen=$i$basename/Неделя/$DATA-Неделя-$basename$rashirenie
                              if [ "$DOW" = "$weekday" ];
                              then
                                  cp "$filemane" "$filemanen"
                                  chmod 777 "$filemanen"
                              fi
                              #Оставляем в папке с бэкапами неделя только copysave резервных копий
                              #find "$pathfilename" -type f -mtime +28 -exec rm -rf {} \;
                              find "$pathfilename" -type f | sort -sr -k1 | tail -n +$copysave | sed 's/^/"/'| sed 's/$/"/' | xargs rm -rf
                              # Разбираемся с месячными копиями
                              pathfilename=$i$basename/Месяц
                              filemanen=$i$basename/Месяц/$DATA-Месяц-$basename$rashirenie
                              if [ "$DAY" = "$monthday" ];
                              then
                                  cp "$filemane" "$filemanen"
                                  chmod 777 "$filemanen"
                              fi
                              #Оставляем в папке с бэкапами месяц только copysave резервных копий
                              #find "$pathfilename" -type f -mtime +112 -exec rm -rf {} \;
                              find "$pathfilename" -type f | sort -sr -k1 | tail -n +$copysave | sed 's/^/"/'| sed 's/$/"/' | xargs rm -rf
                          done

                        ;;
       
       esac

    pathtrue="0"
fi
#Резервная копия создана
    
  shift 1
 done < $file1c

#Включаем apache, что бы восстановить работу 1С
if [[ $apachestop == "1" ]]
    then
        echo "$sudopw" | sudo -S service apache2 start
        sudo systemctl restart apache2
        apachestop="0"
    fi

